package com.connor.jd.plm.action;

import java.util.Arrays;
import java.util.List;

import com.connor.jd.plm.utils.JDMethodUtil;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.common.actions.AbstractAIFAction;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

public class DeleteItemRevisionAction extends AbstractAIFAction {
	private AbstractAIFApplication app;

	public DeleteItemRevisionAction(AbstractAIFApplication arg0, String arg1) {
		super(arg0, arg1);
		this.app = arg0;
		// TODO Auto-generated constructor stub
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		TCSession session = (TCSession) app.getSession();
		InterfaceAIFComponent[] targets = app.getTargetComponents();
		String[] allow = JDMethodUtil.getPrefStrArray("jd2_wltz_Revise_allow", session);
		System.out.println(Arrays.toString(allow));
		List<String> pref = Arrays.asList(allow);
		for (InterfaceAIFComponent target : targets) {
			System.out.println(target.getType());
			if (target instanceof TCComponentItemRevision && pref.contains(target.getType())) {
				TCComponentItemRevision rev = (TCComponentItemRevision) target;
				try {
					String loginUser = session.getUser().getProperty("object_string");
					String owningUser = rev.getProperty("owning_user");
					System.out.println("loginUser===>" + loginUser);
					System.out.println("owningUser===>" + owningUser);
					if (loginUser.equals(owningUser)) {
						TCComponentItem item = rev.getItem();
						TCComponent[] released = item.getReleasedItemRevisions();
						for (TCComponent comp : released) {
							if (comp.getUid().equals(rev.getUid())) {
								MessageBox.post("޷ɾѾ", "ʾ", MessageBox.WARNING);
								return;
							}
						}
						if (!loginUser.equals(item.getProperty("owning_user"))) {
							session.getUserService().call("bs_bypass", new Object[] { true });
							AIFComponentContext[] aifs = rev.whereReferenced();
							for (AIFComponentContext aif : aifs) {
								if (aif.getComponent() instanceof TCComponentItemRevision) {
									TCComponentItemRevision temp = (TCComponentItemRevision) aif.getComponent();
									TCProperty[] tcProps = temp.getAllTCProperties();
									for (TCProperty tcProp : tcProps) {
										TCComponent[] comps = tcProp.getReferenceValueArray();
										for (TCComponent comp : comps) {
											if (comp.getUid().equals(rev.getUid())) {
												temp.cutOperation(tcProp.getPropertyName(), new TCComponent[] { rev });
											}
										}
									}
								} else {
									rev.delete();
								}
							}
							session.getUserService().call("bs_bypass", new Object[] { false });
						}
					}
				} catch (TCException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}

	}

}
